
    LIST P=PIC18F2620
#include	<p18f2620.inc>

	;Programming Configuration Information
    CONFIG     PWRT = ON            ; PWRT enabled
    CONFIG     IESO = ON           ; Oscillator Switchover mode disabled
    CONFIG     FCMEN = ON          ; Fail-Safe Clock Monitor disabled
    CONFIG     OSC=INTIO67          ; INTRC-OSC2 as RA6, OSC1 as RA7
    CONFIG     BOREN = OFF          ; Brown-out Reset disabled in hardware and software
    CONFIG     BORV = 3            ; Minimum setting
    CONFIG     WDT = OFF          ; Watchdog Timer Disabled
    CONFIG     WDTPS = 1            ; 1:1
    CONFIG     MCLRE = OFF          ; RE3 input pin enabled; MCLR disabled
    CONFIG     LPT1OSC = OFF        ; Disabled, T1 operates in standard power mode.
    CONFIG     PBADEN = OFF         ; PORTB<4:0> pins are configured as digital I/O on Reset
    CONFIG     CCP2MX = PORTBE      ; CCP2 input/output is multiplexed with RB3
    CONFIG     STVREN = ON          ; Stack full/underflow will cause Reset
    CONFIG     LVP = OFF            ; Single-Supply ICSP disabled
    CONFIG     XINST = OFF          ; Instruction set extension and Indexed Addressing mode enabled
    CONFIG     DEBUG = OFF          ; Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
 	CONFIG	   CP0=OFF,CP1=OFF,CP2=OFF,CP3=OFF,CPB=OFF,CPD=OFF			; Code protect off
 	CONFIG	   WRT0=OFF,WRT1=OFF,WRT2=OFF,WRT3=OFF,WRTC=OFF,WRTD=OFF	; Write protect off
    CONFIG     EBTR0=OFF,EBTR1=OFF,EBTR2=OFF,EBTR3=OFF,EBTRb=OFF        ; Table Read protect off



;MOVWF W_TEMP ; W_TEMP is in virtual bank
;MOVFF STATUS, STATUS_TEMP ; STATUS_TEMP located anywhere
;MOVFF BSR, BSR_TEMP ; BSR_TMEP located anywhere
;
; USER ISR CODE
;
;MOVFF BSR_TEMP, BSR ; Restore BSR
;MOVF W_TEMP, W ; Restore WREG
;MOVFF STATUS_TEMP, STATUS ; Restore STATUS

;-----------------------------------------------------------------------
    org 	0x0000	;processor reset vector
	goto    main           ;go to beginning of program

;HI_INT_VEC	CODE	0x0008	;interrupt vector location
;	bra		highInt

;--------------------------- INITALIZATION ------------------------------
   org  	0x020	;start PID code here


r0a_in equ 0x30
r0b_in equ 0x31
r1a_in equ 0x32
r1b_in equ 0x33
r2a_in equ 0x34
r2b_in equ 0x35
r3a_in equ 0x36
r3b_in equ 0x37
r4a_in equ 0x38
r4b_in equ 0x39
r5a_in equ 0x3a
r5b_in equ 0x3b
r6a_in equ 0x3c
r6b_in equ 0x3d
r7a_in equ 0x3e
r7b_in equ 0x3f
g0a_in equ 0x40
g0b_in equ 0x41
g1a_in equ 0x42
g1b_in equ 0x43
g2a_in equ 0x44
g2b_in equ 0x45
g3a_in equ 0x46
g3b_in equ 0x47
g4a_in equ 0x48
g4b_in equ 0x49
g5a_in equ 0x4a
g5b_in equ 0x4b
g6a_in equ 0x4c
g6b_in equ 0x4d
g7a_in equ 0x4e
g7b_in equ 0x4f



; -----------------------------------------
drive_leds
; -----------------------------------------

; --- 0 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00000000'
    MOVWF PORTC  

;    B0-7, A0-7 is row data
    MOVF  g0a_in,w
    MOVWF PORTB    

    MOVF  g0b_in,w
    MOVWF PORTA

    call  delay

; --- 1 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r0a_in,w
    MOVWF PORTB    

    MOVF  r0b_in,w
    MOVWF PORTA

    call delay

; --- 2 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g1a_in,w
    MOVWF PORTB    

    MOVF  g1b_in,w
    MOVWF PORTA

    call delay

; --- 3 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r1a_in,w
    MOVWF PORTB    

    MOVF  r1b_in,w
    MOVWF PORTA

    call delay

; --- 4 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01000000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g2a_in,w
    MOVWF PORTB    

    MOVF  g2b_in,w
    MOVWF PORTA

    call delay

; --- 5 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r2a_in,w
    MOVWF PORTB    

    MOVF  r2b_in,w
    MOVWF PORTA

    call delay

; --- 6 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g3a_in,w
    MOVWF PORTB    

    MOVF  g3b_in,w
    MOVWF PORTA

    call delay

; --- 7 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r3a_in,w
    MOVWF PORTB    

    MOVF  r3b_in,w
    MOVWF PORTA

    call delay

; --- 8 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10000000'
    MOVWF PORTC  

;    B0-7, A0-7 is row data
    MOVF  g4a_in,w
    MOVWF PORTB    

    MOVF  g4b_in,w
    MOVWF PORTA

    call  delay

; --- 9 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r4a_in,w
    MOVWF PORTB    

    MOVF  r4b_in,w
    MOVWF PORTA

    call delay

; --- 10 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g5a_in,w
    MOVWF PORTB    

    MOVF  g5b_in,w
    MOVWF PORTA

    call delay

; --- 11 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r5a_in,w
    MOVWF PORTB    

    MOVF  r5b_in,w
    MOVWF PORTA

    call delay

; --- 12 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11000000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g6a_in,w
    MOVWF PORTB    

    MOVF  g6b_in,w
    MOVWF PORTA

    call delay

; --- 13 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r6a_in,w
    MOVWF PORTB    

    MOVF  r6b_in,w
    MOVWF PORTA

    call delay

; --- 14 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g7a_in,w
    MOVWF PORTB    

    MOVF  g7b_in,w
    MOVWF PORTA

    call delay

; --- 15 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r7a_in,w
    MOVWF PORTB    

    MOVF  r7b_in,w
    MOVWF PORTA

    call delay

    return




; *****************************************
main
; *****************************************


    MOVLW 0x70
    IORWF OSCCON,f


	CLRF PORTA ; Initialize PORTA by
	CLRF LATA ; Alternate method
	MOVLW 07h ; Configure I/O
	MOVWF ADCON1 ; Configure A/D for digital
	MOVWF CMCON  ; Configure comparators for digital
	CLRF TRISA ; Set RA<7:0> as outputs



	CLRF PORTB ; Initialize PORTB by
	CLRF LATB ; Alternate method
	MOVLW 0Fh ; Configure I/O
	MOVWF ADCON1 ; Configure A/D for digital
	CLRF TRISB ; Set RB<7:0> as outputs


	CLRF PORTC ; Initialize PORTC by
	CLRF LATC ; Alternate method
	CLRF TRISC ; Set RC<3:0> as outputs

looper equ 0x22
looper1 equ 0x23

top
    movlw  0xff
    movwf  r0a_in
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in 
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 


loop1

    call    drive_leds
    decfsz  looper,1
	goto    loop1

    movlw  0x00
    movwf  r0a_in
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in 
    movlw  0xff
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 

loop2

    call    drive_leds
    decfsz  looper,1
	goto    loop2

    movlw  0xff
    movwf  r0a_in
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in
    movlw  0x00
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 

loop3

    call    drive_leds
    decfsz  looper,1
	goto    loop3

    movlw  0x80
    movwf  r0a_in
    movlw  0x00
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 

loop4

    BCF   STATUS, 0  ; clear the carry bit
    RRCF  r0a_in
    RRCF  r1a_in 
    RRCF  r2a_in 
    RRCF  r3a_in 
    RRCF  r4a_in 
    RRCF  r5a_in
    RRCF  r6a_in 
    RRCF  r7a_in 

    RRCF  r0b_in  
    RRCF  r1b_in 
    RRCF  r2b_in 
    RRCF  r3b_in 
    RRCF  r4b_in 
    RRCF  r5b_in 
    RRCF  r6b_in  
    RRCF  r7b_in


    RRCF  g0a_in 
    RRCF  g1a_in 
    RRCF  g2a_in 
    RRCF  g3a_in 
    RRCF  g4a_in 
    RRCF  g5a_in 
    RRCF  g6a_in 
    RRCF  g7a_in 

    RRCF  g0b_in 
    RRCF  g1b_in 
    RRCF  g2b_in 
    RRCF  g3b_in 
    RRCF  g4b_in 
    RRCF  g5b_in 
    RRCF  g6b_in 
    RRCF  g7b_in 

    movlw  0x10
    movwf  looper1    

loop4a

    call    drive_leds

    decfsz  looper1,1
	goto    loop4a

    decfsz  looper,1
	goto    loop4

    goto    top

count equ 0x20

delay
;
    decfsz      count,1
    goto        delay
    return


	END