
    LIST P=PIC16F726
#include	<P16F726.inc>

    __CONFIG    _CONFIG1, _CP_OFF & _PWRTE_OFF & _BOR_OFF & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF 

;-----------------------------------------------------------------------
    org 	0x0000	;processor reset vector
	goto    main           ;go to beginning of program
    org 	0x0004	;interupt vector
	retfie          ;

;--------------------------- INITALIZATION ------------------------------
   org  	0x020	;start PID code here

count   equ 0x20
count1  equ 0x21
looper  equ 0x22
looper1 equ 0x23

r0a_in equ 0x30
r0b_in equ 0x31
r1a_in equ 0x32
r1b_in equ 0x33
r2a_in equ 0x34
r2b_in equ 0x35
r3a_in equ 0x36
r3b_in equ 0x37
r4a_in equ 0x38
r4b_in equ 0x39
r5a_in equ 0x3a
r5b_in equ 0x3b
r6a_in equ 0x3c
r6b_in equ 0x3d
r7a_in equ 0x3e
r7b_in equ 0x3f
g0a_in equ 0x40
g0b_in equ 0x41
g1a_in equ 0x42
g1b_in equ 0x43
g2a_in equ 0x44
g2b_in equ 0x45
g3a_in equ 0x46
g3b_in equ 0x47
g4a_in equ 0x48
g4b_in equ 0x49
g5a_in equ 0x4a
g5b_in equ 0x4b
g6a_in equ 0x4c
g6b_in equ 0x4d
g7a_in equ 0x4e
g7b_in equ 0x4f




; -----------------------------------------
drive_leds
; -----------------------------------------

; --- 0 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00000000'
    MOVWF PORTC  

;    B0-7, A0-7 is row data
    MOVF  g0a_in,w
    MOVWF PORTB    

    MOVF  g0b_in,w
    MOVWF PORTA

    call  delay

; --- 1 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r0a_in,w
    MOVWF PORTB    

    MOVF  r0b_in,w
    MOVWF PORTA

    call delay

; --- 2 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g1a_in,w
    MOVWF PORTB    

    MOVF  g1b_in,w
    MOVWF PORTA

    call delay

; --- 3 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'00100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r1a_in,w
    MOVWF PORTB    

    MOVF  r1b_in,w
    MOVWF PORTA

    call delay

; --- 4 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01000000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g2a_in,w
    MOVWF PORTB    

    MOVF  g2b_in,w
    MOVWF PORTA

    call delay

; --- 5 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r2a_in,w
    MOVWF PORTB    

    MOVF  r2b_in,w
    MOVWF PORTA

    call delay

; --- 6 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g3a_in,w
    MOVWF PORTB    

    MOVF  g3b_in,w
    MOVWF PORTA

    call delay

; --- 7 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'01100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r3a_in,w
    MOVWF PORTB    

    MOVF  r3b_in,w
    MOVWF PORTA

    call delay

; --- 8 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10000000'
    MOVWF PORTC  

;    B0-7, A0-7 is row data
    MOVF  g4a_in,w
    MOVWF PORTB    

    MOVF  g4b_in,w
    MOVWF PORTA

    call  delay

; --- 9 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r4a_in,w
    MOVWF PORTB    

    MOVF  r4b_in,w
    MOVWF PORTA

    call delay

; --- 10 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g5a_in,w
    MOVWF PORTB    

    MOVF  g5b_in,w
    MOVWF PORTA

    call delay

; --- 11 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'10100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r5a_in,w
    MOVWF PORTB    

    MOVF  r5b_in,w
    MOVWF PORTA

    call delay

; --- 12 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11000000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g6a_in,w
    MOVWF PORTB    

    MOVF  g6b_in,w
    MOVWF PORTA

    call delay

; --- 13 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11000001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r6a_in,w
    MOVWF PORTB    

    MOVF  r6b_in,w
    MOVWF PORTA

    call delay

; --- 14 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11100000'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  g7a_in,w
    MOVWF PORTB    

    MOVF  g7b_in,w
    MOVWF PORTA

    call delay

; --- 15 ----
;    C7,C6,C5,C0 = 16 bit column select
    MOVLW b'11100001'
    MOVWF PORTC 

;    B0-7, A0-7 is row data
    MOVF  r7a_in,w
    MOVWF PORTB    

    MOVF  r7b_in,w
    MOVWF PORTA

    call delay

    return




; *****************************************
main
; *****************************************

;    banksel OSCCON
;    MOVLW 0x70
;    IORWF OSCCON,f

    banksel PORTA
	CLRF PORTA ; Initialize PORTA by
    BANKSEL ANSELA ;
    CLRF ANSELA
    BANKSEL TRISA
	CLRF TRISA
    

    BANKSEL PORTB ;
    CLRF PORTB ;Init PORTB
    BANKSEL ANSELB
    CLRF ANSELB ;Make RB<7:0> digital
    BANKSEL TRISB ;
    CLRF TRISB ;


    BANKSEL PORTC ;
    CLRF PORTC ;Init PORTC
    BANKSEL TRISC ;
    MOVLW B'00011110' 
    MOVWF TRISC ;

    banksel PORTA

    goto loop3a

looper equ 0x22
looper1 equ 0x23

top
    movlw  0xff
    movwf  r0a_in
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in 
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 


loop1

    call    drive_leds
    decfsz  looper,1
	goto    loop1

loop1a
    movlw  0x00
    movwf  r0a_in
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in 
    movlw  0xff
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 

loop2

    call    drive_leds
    decfsz  looper,1
	goto    loop2

    movlw  0xff
    movwf  r0a_in
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in
    movlw  0x00
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 

loop3

    call    drive_leds
    decfsz  looper,1
	goto    loop3

loop3a

    movlw  0xF0
    movwf  r0a_in
;    movlw  0x00
    movwf  r0b_in 
    movwf  r1a_in 
    movwf  r1b_in 
    movwf  r2a_in 
    movwf  r2b_in 
    movwf  r3a_in 
    movwf  r3b_in 
    movwf  r4a_in 
    movwf  r4b_in 
    movwf  r5a_in
    movwf  r5b_in
    movwf  r6a_in 
    movwf  r6b_in 
    movwf  r7a_in 
    movwf  r7b_in
    movwf  g0a_in 
    movwf  g0b_in 
    movwf  g1a_in 
    movwf  g1b_in 
    movwf  g2a_in 
    movwf  g2b_in 
    movwf  g3a_in 
    movwf  g3b_in 
    movwf  g4a_in 
    movwf  g4b_in 
    movwf  g5a_in 
    movwf  g5b_in 
    movwf  g6a_in 
    movwf  g6b_in 
    movwf  g7a_in 
    movwf  g7b_in 

loop4

    BCF   STATUS, C  ; clear the carry bit
    RRF  r0a_in,f
    RRF  r1a_in,f
    RRF  r2a_in,f 
    RRF  r3a_in,f 
    RRF  r4a_in,f 
    RRF  r5a_in,f
    RRF  r6a_in,f 
    RRF  r7a_in,f 

    RRF  r0b_in,f  
    RRF  r1b_in,f 
    RRF  r2b_in,f 
    RRF  r3b_in,f 
    RRF  r4b_in,f 
    RRF  r5b_in,f 
    RRF  r6b_in,f 
    RRF  r7b_in,f

    RRF  g0a_in,f 
    RRF  g1a_in,f 
    RRF  g2a_in,f 
    RRF  g3a_in,f 
    RRF  g4a_in,f 
    RRF  g5a_in,f 
    RRF  g6a_in,f 
    RRF  g7a_in,f 

    RRF  g0b_in,f 
    RRF  g1b_in,f 
    RRF  g2b_in,f 
    RRF  g3b_in,f 
    RRF  g4b_in,f 
    RRF  g5b_in,f 
    RRF  g6b_in,f 
    RRF  g7b_in,f 

    movlw  0x40
    movwf  looper1    

loop4a

    call    drive_leds

   decfsz  looper1,f
   goto    loop4a

    decfsz  looper,f
	goto    loop4

    goto    top

delay
;
    decfsz      count,1
    goto        delay

    return


	END